#include < amxmodx >
#include < nvault >
#include < reapi >
#include <devms_core>

#pragma semicolon 1

//#define KEEP_LOGS__MS_OTHER												// Вести журналы для ведение прочих хешей
#define KEEP_LOGS__MS_UNKNOWN												// Вести журналы для ведение неизвестных хешей


#define STEAM																// Игнорировать STEAM игроков и помечать отдельно
//#define GS_STEAM															// Проверка связки стим + ГС
//#define GS_CHECK															// Игнорировать GS игроков и помечать отдельно


//new const HASHES_DIRECTORY[ ]				=	"/addons/rechecker/dlls/";	// Путь до директории хранилища данных с использованием /dlls/
new const HASHES_DIRECTORY[ ]				=	"/addons/rechecker/";		// Путь до директории хранилища данных без /dlls/

new const HASHES_FILE_NAME[ ]				=	"ms_hashes.ini";			// Наименование файла хранилища данных

new const VAULT_ONLINE__FOLDER_NAME[ ]		=	"online_players";			// Наименование директории хранилища онлайна игроков
new const VAULT_ONLINE__FILE_NAME[ ]		=	"online_players";			// Наименование файла хранилища онлайна игроков

new const LOGS_FOLDER_NAME[ ]				=	"ms_check";					// Наименование каталога ведение журналов

new const LOGS_FILE_NAME__MS_KNOWN[ ]		=	"ms_log";					// Наименование журналов для ведение информации известных хешей

#if defined KEEP_LOGS__MS_UNKNOWN
	new const LOGS_FILE_NAME__MS_UNKNOWN[ ]	=	"ms_unknown";				// Наименование журналов для ведение информации неизвестных хешей
#endif

#if defined KEEP_LOGS__MS_OTHER
	new const LOGS_FILE_NAME__MS_OTHER[ ]	=	"ms_other";					// Наименование журналов для ведение прочих хешей
#endif

const INACTIVITY_ONLINE_DAYS				=	90;							// Удалять онлайн неактивных игроков отсутствующих 'n' дней на сервере
const INACTIVITY_STATUS_DAYS				=	10;							// Удалять статус постоянных игроков отсутствующих 'n' дней на сервере
const DELAY_RETURN_STATUS					=	4;							// Отсрочка для возврата статуса постоянного игрока поигравшего 'n' часов на сервере

const SECONDS_IN_DAY						=	86400;						// Количество секунд в одном дне, необходимых для INACTIVITY_DAYS
const SECONDS_IN_HOUR						=	3600;						// Количество секунд в одном часе, необходимых для RETURN_STATUS

#if defined STEAM
new MS_STEAM[ ]								=	"[STEAM]";					// МС STEAM
#endif


#if defined GS_CHECK
new MS_GSCLIENT[ ]							=	"[GSCLIENT]";				// МС GSCLIENT
#endif


new MS_UNKNOWN[ ]							=	"[UNKNOWN]";				// МС UNKNOWN

#if defined KEEP_LOGS__MS_OTHER
	new MS_DOUBLE[ ]						=	"[DOUBLE]";					// МС DOUBLE
	new MS_ERROR[ ]							=	"[ERROR]";					// МС ERROR
#endif

const FIRST_CELL							=	0;
const FLAG_NUM_LINES						=	1;
const ELLIPSES_ARG							=	4;
const DP_PROTOCOL							=	48;
const DP_AUTH_REVEMU						=	4;
const START_DATE							=	0;
const INVALID_VALUE							=	-1;
const NULLED								=	0;

const MAX_LENGTH__ONLINE_PLAYER				=	15;
const MAX_LENGTH__STATUS_PLAYER				=	32;
const MAX_LENGTH__QUOTE_STRING				=	128;
const MAX_LENGTH__PATH						=	64;
const MAX_LENGTH__LINE						=	512;
const MAX_LENGTH__MS_CONTENT				=	256;
const MAX_LENGTH__MS_FILE					=	64;
const MAX_LENGTH__MS_HASH					=	32;
const MAX_LENGTH__MS_NAME					=	32;
const MAX_LENGTH__AUTHID					=	64;
const MAX_LENGTH__NAME						=	32;
const MAX_LENGTH__IP						=	16;
const MAX_LENGTH__TIME						=	32;
const MAX_LENGTH__FILE						=	96;
const MAX_LENGTH__MESSAGE					=	512;

enum _: MS_DATA
{
	MS__MS_FILE[ MAX_LENGTH__MS_FILE ],
	MS__MS_HASH[ MAX_LENGTH__MS_HASH ],
	MS__MS_NAME[ MAX_LENGTH__MS_NAME ]
}

enum _: ONLINE_PLAYER_ENUM
{
	ONLINE_PLAYER__NEW,
	ONLINE_PLAYER__PASSERBY,
	ONLINE_PLAYER__VISITORS,
	ONLINE_PLAYER__REGULAR,
	ONLINE_PLAYER__ELDERLY
}

enum _: STATUS_PLAYER_STRUCT
{
	STATUS_PLAYER__STATUS[ MAX_LENGTH__STATUS_PLAYER ],
	STATUS_PLAYER__ONLINE
}

new const STATUS_PLAYER[ ONLINE_PLAYER_ENUM ][ STATUS_PLAYER_STRUCT ] =
{
	{	"[НОВЫЕ]",			0			},	// Игроки, которые еще ни разу не заходили к Вам на сервер
	{	"[ОТКАЗЫ]",			1			},	// Игроки, которые вышли с сервера поиграв менее 5 минут
	{	"[ОСТАЛЬНЫЕ]",		300			},	// Игроки, которые не являются новыми, но еще и не постоянными
	{	"[ПОСТОЯННЫЕ]",		36000		},	// Игроки, играющие на Вашем сервере более 10 часов
	{	"[ПОЖИЛЫЕ]",		180000		}	// Игроки, играющие на Вашем сервере более 50 часов
};

new g_iVaultID;

#if defined GS_STEAM
new g_dpProvider;
new g_dpProtocol;
#endif

new g_sLogsDir[ MAX_LENGTH__PATH ];
new g_sMsHashesFile[ MAX_LENGTH__PATH + 32 ];

new g_eMs[ MS_DATA ];
new g_eMsKnown[ MS_DATA ];
new g_eMsUnknown[ MS_DATA ];

new g_iOnlinePlayer[ MAX_PLAYERS + 1 ];
new g_iOnlineDelay[ MAX_PLAYERS + 1 ];
new g_iSessionID[ MAX_PLAYERS + 1 ];
new g_sSessionFile[ MAX_PLAYERS + 1 ][ MAX_LENGTH__FILE ];
new g_sStatusPlayer[ MAX_PLAYERS + 1 ][ MAX_LENGTH__STATUS_PLAYER ];

#if defined STEAM
new bool: g_bSteam[ MAX_PLAYERS + 1 ];
#endif
#if defined GS_STEAM
new bool: g_bGsClient[ MAX_PLAYERS + 1 ];
#endif
new bool: g_bMsKnown[ MAX_PLAYERS + 1 ];
new bool: g_bAuthPlayer[ MAX_PLAYERS + 1 ];
new bool: g_bStatusDelay[ MAX_PLAYERS + 1 ];

new Array: g_aMs;
new Array: g_aMsKnown[ MAX_PLAYERS + 1 ];
new Array: g_aMsUnknown[ MAX_PLAYERS + 1 ];

new Trie: g_tMsFiles;
new Trie: g_tMsHashes;
new Trie: g_tMsVerified[ MAX_PLAYERS + 1 ];

public plugin_init( )
{
	register_plugin( "Master Servers Check", "4.8", "Javekson" );
	
	RegisterHookChain( RC_FileConsistencyProcess, "FileConsistencyProcess", .post = true );
	RegisterHookChain( RC_FileConsistencyFinal, "FileConsistencyFinal", .post = true );
}

public plugin_cfg( )
{
	formatex( g_sMsHashesFile, charsmax( g_sMsHashesFile ), "%s/%s", HASHES_DIRECTORY, HASHES_FILE_NAME );
	
	get_localinfo( "amxx_logs", g_sLogsDir, charsmax( g_sLogsDir ) );
	
	formatex( g_sLogsDir, charsmax( g_sLogsDir ), "%s/%s", g_sLogsDir, LOGS_FOLDER_NAME );
	
	if( !dir_exists( g_sLogsDir ) )
	{
		mkdir( g_sLogsDir );
	}
	
	#if defined GS_STEAM
	g_dpProvider = get_cvar_pointer( "dp_r_id_provider" );
	g_dpProtocol = get_cvar_pointer( "dp_r_protocol" );
	#endif
	
	g_aMs = ArrayCreate( MS_DATA );
	
	g_tMsFiles = TrieCreate( );
	g_tMsHashes = TrieCreate( );
	
	for( new i = 1; i <= MAX_PLAYERS; i++ )
	{
		g_aMsKnown[ i ] = ArrayCreate( MS_DATA );
		g_aMsUnknown[ i ] = ArrayCreate( MS_DATA );
		
		g_tMsVerified[ i ] = TrieCreate( );
	}
	
	func_ReadMsHashesFile( );
	
	/* -------------------------------------------- */
	
	new sVaultDir[ MAX_LENGTH__PATH ];
	get_localinfo( "amxx_datadir", sVaultDir, charsmax( sVaultDir ) );
	
	formatex( sVaultDir, charsmax( sVaultDir ), "%s/vault/%s", sVaultDir, VAULT_ONLINE__FOLDER_NAME );
	
	if( !dir_exists( sVaultDir ) )
	{
		mkdir( sVaultDir );
	}
	
	new sVaultName[ MAX_LENGTH__PATH + 32 ];
	formatex( sVaultName, charsmax( sVaultName ), "%s/%s", VAULT_ONLINE__FOLDER_NAME, VAULT_ONLINE__FILE_NAME );
	
	g_iVaultID = nvault_open( sVaultName );
	
	nvault_prune( g_iVaultID, START_DATE, get_systime( ) - SECONDS_IN_DAY * INACTIVITY_ONLINE_DAYS );
}


public client_authorized( id )
{
	#if defined GS_STEAM
	func_GSClientCheck( id );
	#endif
	
	#if defined STEAM
	func_SteamClientCheck( id );
	#endif
}

public client_disconnected( id )
{
	g_bMsKnown[ id ] = false;
	
	ArrayClear( g_aMsKnown[ id ] );
	
	ArrayClear( g_aMsUnknown[ id ] );
	
	TrieClear( g_tMsVerified[ id ] );
	
	/* -------------------------------------------- */
	
	new sAuthID[ MAX_LENGTH__AUTHID ];
	get_user_authid( id, sAuthID, charsmax( sAuthID ) );
	
	if( g_bAuthPlayer[ id ] && sAuthID[ 0 ] )
	{
		g_iOnlinePlayer[ id ] += get_user_time( id );
		
		if( g_bStatusDelay[ id ] )
		{
			g_iOnlineDelay[ id ] += get_user_time( id );
		}
		
		new sOnlinePlayer[ MAX_LENGTH__ONLINE_PLAYER ];
		num_to_str( g_iOnlinePlayer[ id ], sOnlinePlayer, charsmax( sOnlinePlayer ) );
		
		new sOnlineDelay[ MAX_LENGTH__ONLINE_PLAYER ];
		num_to_str( g_iOnlineDelay[ id ], sOnlineDelay, charsmax( sOnlineDelay ) );
		
		new sOnline[ MAX_LENGTH__ONLINE_PLAYER ];
		formatex( sOnline, charsmax( sOnline ), "%s %s", sOnlinePlayer, sOnlineDelay );
		
		nvault_set( g_iVaultID, sAuthID, sOnline );
		
		new iOnlineVisitors = STATUS_PLAYER[ ONLINE_PLAYER__VISITORS ][ STATUS_PLAYER__ONLINE ];
		
		if( g_iOnlinePlayer[ id ] < iOnlineVisitors )
		{
			new sLineCache[ MAX_LENGTH__LINE ];
			read_file( g_sSessionFile[ id ], g_iSessionID[ id ], sLineCache, charsmax( sLineCache ) );
			
			new sStatusPasserby[ MAX_LENGTH__STATUS_PLAYER ];
			copy( sStatusPasserby, charsmax( sStatusPasserby ), STATUS_PLAYER[ ONLINE_PLAYER__PASSERBY ][ STATUS_PLAYER__STATUS ] );
			
			replace( sLineCache, charsmax( sLineCache ), g_sStatusPlayer[ id ], sStatusPasserby );
			
			write_file( g_sSessionFile[ id ], sLineCache, g_iSessionID[ id ] );
		}
	}
	
	g_iOnlinePlayer[ id ] = NULLED;
	g_iOnlineDelay[ id ] = NULLED;
	
	g_bAuthPlayer[ id ] = false;
	
	g_bStatusDelay[ id ] = false;
}

public plugin_end( )
{
	ArrayDestroy( g_aMs );
	
	TrieDestroy( g_tMsFiles );
	TrieDestroy( g_tMsHashes );
	
	for( new i = 1; i <= MAX_PLAYERS; i++ )
	{
		ArrayDestroy( g_aMsKnown[ i ] );
		ArrayDestroy( g_aMsUnknown[ i ] );
		
		TrieDestroy( g_tMsVerified[ i ] );
	}
	
	nvault_close( g_iVaultID );
}

func_ReadMsHashesFile( )
{
	new iFileID = fopen( g_sMsHashesFile, "rt" );
	
	new sMsContent[ MAX_LENGTH__MS_CONTENT ], sMsFile[ MAX_LENGTH__MS_FILE ], sMsHash[ MAX_LENGTH__MS_HASH ], sMsName[ MAX_LENGTH__MS_NAME ];
	
	while( !feof( iFileID ) )
	{
		fgets( iFileID, sMsContent, charsmax( sMsContent ) );
		
		trim( sMsContent );
		
		if( !sMsContent[ 0 ] || sMsContent[ 0 ] == ';' )
		{
			continue;
		}
		
		parse( sMsContent, sMsFile, charsmax( sMsFile ), sMsHash, charsmax( sMsHash ), sMsName, charsmax( sMsName ) );
		
		strtolower( sMsHash );
		
		if( equal( sMsHash, "any" ) )
		{
			if( !TrieKeyExists( g_tMsFiles, sMsFile ) )
			{
				TrieSetCell( g_tMsFiles, sMsFile, true );
				
				RegisterQueryFile( sMsFile, "handler_MsQueryFile", RES_TYPE_HASH_ANY );
			}
		}
		else
		{
			g_eMs[ MS__MS_FILE ] = sMsFile;
			g_eMs[ MS__MS_HASH] = sMsHash;
			g_eMs[ MS__MS_NAME ] = sMsName;
			
			ArrayPushArray( g_aMs, g_eMs );
			
			if( !TrieKeyExists( g_tMsFiles, sMsFile ) )
			{
				TrieSetCell( g_tMsFiles, sMsFile, true );
				
				RegisterQueryFile( sMsFile, "handler_MsQueryFile", RES_TYPE_HASH_ANY );
			}
			
			TrieSetString( g_tMsHashes, sMsHash, sMsName );
		}
	}
	
	fclose( iFileID );
}

public FileConsistencyProcess( const id, const sFile[ ], const sCmd[ ], const ResourceType: eType, const iHash )
{
	if( iHash )
	{
		if( TrieKeyExists( g_tMsFiles, sFile ) )
		{
			
			/* ---------- Проверка дублей, костыль для тех кто одновременно пользуется анализатором ---------- */
			
			if( TrieKeyExists( g_tMsVerified[ id ], sFile ) )
			{
				return PLUGIN_CONTINUE;
			}
			
			TrieSetCell( g_tMsVerified[ id ], sFile, true );
			
			/* ----------------------------------------------------------------------------------------------- */
			
			new sAuthID[ MAX_LENGTH__AUTHID ];
			get_user_authid( id, sAuthID, charsmax( sAuthID ) );
			
			new sPlayerIP[ MAX_LENGTH__IP ];
			get_user_ip( id, sPlayerIP, charsmax( sPlayerIP ), .without_port = true );
			
			new sPlayerName[ MAX_LENGTH__NAME ];
			get_user_name( id, sPlayerName, charsmax( sPlayerName ) );
			
			new sMsFile[ MAX_LENGTH__MS_FILE ];
			formatex( sMsFile, charsmax( sMsFile ), "%s", sFile );
			
			new sMsHash[ MAX_LENGTH__MS_HASH ];
			formatex( sMsHash, charsmax( sMsHash ), "%s", func_ByteToStringLE( iHash ) );
			
			strtolower( sMsHash );
			
			if( TrieKeyExists( g_tMsHashes, sMsHash ) )
			{
				new bool: bState;
				
				new sMsName[ MAX_LENGTH__MS_NAME ];
				TrieGetString( g_tMsHashes, sMsHash, sMsName, charsmax( sMsName ) );
				
				for( new i; i < ArraySize( g_aMs ); i++ )
				{
					ArrayGetArray( g_aMs, i, g_eMs );
					
					if( equal( g_eMs[ MS__MS_FILE ], sMsFile ) && equal( g_eMs[ MS__MS_HASH ], sMsHash ) && equal( g_eMs[ MS__MS_NAME ], sMsName ) )
					{
						bState = true;
						
						g_bMsKnown[ id ] = true;
						
						g_eMsKnown[ MS__MS_FILE ] = sMsFile;
						g_eMsKnown[ MS__MS_HASH ] = sMsHash;
						g_eMsKnown[ MS__MS_NAME ] = sMsName;
						
						ArrayPushArray( g_aMsKnown[ id ], g_eMsKnown );
						
						break;
					}
				}
				
				if( !bState )
				{
					#if defined KEEP_LOGS__MS_OTHER
						func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_OTHER, "%-24s %-24s %-32s %-24s %-32s %-48s %s", func_QuoteString( MS_ERROR ), func_QuoteString( sMsName ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sPlayerName ), func_QuoteString( sMsFile ), func_QuoteString( sMsHash ) );
					#endif
				}
			}
			else
			{
				g_eMsUnknown[ MS__MS_FILE ] = sMsFile;
				g_eMsUnknown[ MS__MS_HASH ] = sMsHash;
				
				ArrayPushArray( g_aMsUnknown[ id ], g_eMsUnknown );
			}
		}
	}
	
	return PLUGIN_CONTINUE;
}

public FileConsistencyFinal( const id )
{
	new sAuthID[ MAX_LENGTH__AUTHID ];
	get_user_authid( id, sAuthID, charsmax( sAuthID ) );
	
	new sPlayerIP[ MAX_LENGTH__IP ];
	get_user_ip( id, sPlayerIP, charsmax( sPlayerIP ), .without_port = true );
	
	new sPlayerName[ MAX_LENGTH__NAME ];
	get_user_name( id, sPlayerName, charsmax( sPlayerName ) );
	
	g_bAuthPlayer[ id ] = true;
	
	/* -------------------------------------------- */
	
	new sOnline[ MAX_LENGTH__ONLINE_PLAYER ], iTimeStamp;
	
	if( nvault_lookup( g_iVaultID, sAuthID, sOnline, charsmax( sOnline ), iTimeStamp ) )
	{
		new sOnlinePlayer[ MAX_LENGTH__ONLINE_PLAYER ], sOnlineDelay[ MAX_LENGTH__ONLINE_PLAYER ];
		
		parse( sOnline, sOnlinePlayer, charsmax( sOnlinePlayer ), sOnlineDelay, charsmax( sOnlineDelay ) );
		
		g_iOnlinePlayer[ id ] = str_to_num( sOnlinePlayer );
		
		g_iOnlineDelay[ id ] = str_to_num( sOnlineDelay );
		
		new iNumMissedDays = get_systime( ) - iTimeStamp;
		
		new iInactivityStatusDays = SECONDS_IN_DAY * INACTIVITY_STATUS_DAYS;
		
		new iDelayReturnStatus = SECONDS_IN_HOUR * DELAY_RETURN_STATUS;
		
		new iOnlineRegular = STATUS_PLAYER[ ONLINE_PLAYER__REGULAR ][ STATUS_PLAYER__ONLINE ];
		
		if( g_iOnlinePlayer[ id ] >= iOnlineRegular )
		{
			if( iNumMissedDays > iInactivityStatusDays || g_iOnlineDelay[ id ] && g_iOnlineDelay[ id ] < iDelayReturnStatus )
			{
				g_bStatusDelay[ id ] = true;
			}
			else
			{
				g_iOnlineDelay[ id ] = NULLED;
			}
		}
		
		nvault_touch( g_iVaultID, sAuthID );
	}
	
	new sStatusPlayer[ MAX_LENGTH__STATUS_PLAYER ];
	copy( sStatusPlayer, charsmax( sStatusPlayer ), func_GetStatusPlayer( id ) );
	
	g_sStatusPlayer[ id ] = sStatusPlayer;
	
	new sFileTime[ MAX_LENGTH__TIME ];
	get_time( "%d.%m.%Y", sFileTime, charsmax( sFileTime ) );
	
	formatex( g_sSessionFile[ id ], charsmax( g_sSessionFile[ ] ), "%s/%s_%s.log", g_sLogsDir, LOGS_FILE_NAME__MS_KNOWN, sFileTime );
	
	g_iSessionID[ id ] = file_size( g_sSessionFile[ id ], .flag = FLAG_NUM_LINES ) - 1;
	
	if( g_iSessionID[ id ] <= INVALID_VALUE )
	{
		g_iSessionID[ id ] = NULLED;
	}
	
	/* -------------------------------------------- */
	
	#if defined STEAM
	if( g_bSteam[ id ] )
	{
		if(!dc_gs_client(id))
		{
			func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_KNOWN, "%-24s %-32s %-24s %-32s %s", func_QuoteString( MS_STEAM ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sStatusPlayer ), func_QuoteString( sPlayerName ) );
			return PLUGIN_CONTINUE;
		}
	}
	#endif
	
	#if defined GS_CHECK
	if( !g_bMsKnown[ id ] && g_bGsClient[ id ] )
	{
		func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_KNOWN, "%-24s %-32s %-24s %-32s %s", func_QuoteString( MS_GSCLIENT ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sStatusPlayer ), func_QuoteString( sPlayerName ) );
		
		return PLUGIN_CONTINUE;
	}
	#endif
	
	if( g_bMsKnown[ id ] )
	{
		ArrayGetArray( g_aMsKnown[ id ], FIRST_CELL, g_eMsKnown );
		
		func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_KNOWN, "%-24s %-32s %-24s %-32s %-32s %-48s %s", func_QuoteString( g_eMsKnown[ MS__MS_NAME ] ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sStatusPlayer ), func_QuoteString( sPlayerName ), func_QuoteString( g_eMsKnown[ MS__MS_FILE ] ), func_QuoteString( g_eMsKnown[ MS__MS_HASH ] ) );
		
		new sMsName[ MAX_LENGTH__MS_NAME ];
		formatex( sMsName, charsmax( sMsName ), "%s", g_eMsKnown[ MS__MS_NAME ] );
		
		#if defined KEEP_LOGS__MS_OTHER
			for( new i = 1; i < ArraySize( g_aMsKnown[ id ] ); i++ )
			{
				ArrayGetArray( g_aMsKnown[ id ], i, g_eMsKnown );
				
				if( !equal( sMsName, g_eMsKnown[ MS__MS_NAME ] ) )
				{
					func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_OTHER, "%-24s %-24s %-32s %-24s %-32s %-48s %s", func_QuoteString( MS_DOUBLE ), func_QuoteString( g_eMsKnown[ MS__MS_NAME ] ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sPlayerName ), func_QuoteString( g_eMsKnown[ MS__MS_FILE ] ), func_QuoteString( g_eMsKnown[ MS__MS_HASH ] ) );
				}
			}
		#endif
	}
	else
	{
		#if defined KEEP_LOGS__MS_UNKNOWN
			for( new i; i < ArraySize( g_aMsUnknown[ id ] ); i++ )
			{
				ArrayGetArray( g_aMsUnknown[ id ], i, g_eMsUnknown );
				
				func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_UNKNOWN, "%-48s %-16s %-32s %-24s %s", func_QuoteString( g_eMsUnknown[ MS__MS_FILE ] ), func_QuoteString( g_eMsUnknown[ MS__MS_HASH ] ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sPlayerName ) );
			}
			
			func_SetLogBlankLine( g_sLogsDir, LOGS_FILE_NAME__MS_UNKNOWN );
		#endif
		
		func_Logging( g_sLogsDir, LOGS_FILE_NAME__MS_KNOWN, "%-24s %-32s %-24s %-32s %s", func_QuoteString( MS_UNKNOWN ), func_QuoteString( sAuthID ), func_QuoteString( sPlayerIP ), func_QuoteString( sStatusPlayer ), func_QuoteString( sPlayerName ) );
	}
	
	return PLUGIN_CONTINUE;
}

public handler_MsQueryFile( ) { }

#if defined GS_STEAM
stock func_GSClientCheck( const id )
{
	server_cmd( "dp_clientinfo %d", id );
	server_exec( );
	
	if( get_pcvar_num( g_dpProtocol ) == DP_PROTOCOL )
	{
		if( get_pcvar_num( g_dpProvider ) == DP_AUTH_REVEMU )
		{
			query_client_cvar( id, "voice_quality", "QueryClientCvar_VoiceQuality" );
		}
	}
}


public QueryClientCvar_VoiceQuality( const id, const sCvar[ ], const sValue[ ] )
{
	g_bGsClient[ id ] = bool: ( !equali( sValue, "Bad CVAR request" ) );
}
#endif


#if defined STEAM
stock func_SteamClientCheck( const id )
{
	g_bSteam[ id ] = is_user_steam( id );
}
#endif

stock func_ByteToStringLE( iMsHash )
{
	new sMsHash[ MAX_LENGTH__MS_HASH ];
	formatex( sMsHash, charsmax( sMsHash ), "%02X%02X%02X%02X", ( iMsHash ) & 0xff, ( iMsHash >> 8 ) & 0xff, ( iMsHash >> 16 ) & 0xff, ( iMsHash >> 24 ) & 0xff );
	
	return sMsHash;
}

stock func_QuoteString( sString[ ] )
{
	new sQuoteString[ MAX_LENGTH__QUOTE_STRING ];
	formatex( sQuoteString, charsmax( sQuoteString ), "^"%s^"", ( sString ) );
	
	return sQuoteString;
}

stock func_GetStatusPlayer( const id )
{
	new sStatus[ MAX_LENGTH__STATUS_PLAYER ];
	
	if( g_bStatusDelay[ id ] )
	{
		copy( sStatus, charsmax( sStatus ), STATUS_PLAYER[ ONLINE_PLAYER__VISITORS ][ STATUS_PLAYER__STATUS ] );
		
		return sStatus;
	}
	
	new iPtr;
	
	for( new i; i < sizeof( STATUS_PLAYER ); i++ )
	{
		if( g_iOnlinePlayer[ id ] >= STATUS_PLAYER[ i ][ STATUS_PLAYER__ONLINE ] )
		{
			iPtr = i;
		}
	}
	
	new iOnlineCache = STATUS_PLAYER[ iPtr ][ STATUS_PLAYER__ONLINE ];
	
	new iOnlinePasserby = STATUS_PLAYER[ ONLINE_PLAYER__PASSERBY ][ STATUS_PLAYER__ONLINE ];
	
	if( iOnlineCache == iOnlinePasserby )
	{
		iPtr++;
	}
	
	copy( sStatus, charsmax( sStatus ), STATUS_PLAYER[ iPtr ][ STATUS_PLAYER__STATUS ] );
	
	return sStatus;
}

stock func_SetLogBlankLine( const sLogsDir[ ], const sFileName[ ] )
{
	new sFileTime[ MAX_LENGTH__TIME ];
	get_time( "%d.%m.%Y", sFileTime, charsmax( sFileTime ) );
	
	new sLogFile[ MAX_LENGTH__PATH + 32 ];
	formatex( sLogFile, charsmax( sLogFile ), "%s/%s_%s.log", sLogsDir, sFileName, sFileTime );
	
	new iFileID = fopen( sLogFile, "at" );
	
	fprintf( iFileID, "^n" );
	
	fclose( iFileID );
}

stock func_Logging( const sLogsDir[ ], const sFileName[ ], const sMessage[ ], any:... )
{
	new sFmtMsg[ MAX_LENGTH__MESSAGE ];
	vformat( sFmtMsg, charsmax( sFmtMsg ), sMessage, ELLIPSES_ARG );
	
	new sFileTime[ MAX_LENGTH__TIME ];
	get_time( "%d.%m.%Y", sFileTime, charsmax( sFileTime ) );
	
	new sLogFile[ MAX_LENGTH__PATH + 32 ];
	formatex( sLogFile, charsmax( sLogFile ), "%s/%s_%s.log", sLogsDir, sFileName, sFileTime );
	
	new iFileID = fopen( sLogFile, "at" );
	
	new sRecordTime[ MAX_LENGTH__TIME ];
	get_time( "%d.%m.%Y - %H:%M:%S", sRecordTime, charsmax( sRecordTime ) );
	
	fprintf( iFileID, "^"%s^" %s^n", sRecordTime, sFmtMsg );
	
	fclose( iFileID );
}